;********************************************************************
;			File: MACROS.ASM
;********************************************************************
BANK0	MACRO
	BCF     STATUS, RP0     ; Select Bank 0
	ENDM
BANK1	MACRO
	BSF     STATUS, RP0     ; Select Bank 1
	ENDM
;********************************************************************
MOVE	MACRO	variable,value
	BANK0			;assume that variable is in bank 0
	MOVLW	value
	MOVWF	variable
	ENDM
;********************************************************************

COL	MACRO	port,bit
	BCF	port,bit		;clear column bit
	CALL	ROWCHECK		;check rows
	BSF	port,bit		;set column bit
	ENDM
;********************************************************************
TABLE	MACRO	table,offset	;call table in another page,table offset
	MOVLW	HIGH table	;get high part of table address
	MOVWF	PCLATH
	MOVF	offset,W
	CALL	table
	ENDM
;********************************************************************
FIXPCLATH	MACRO	label
	MOVWF	TEMPW
	MOVLW	HIGH label
	MOVWF	PCLATH
	MOVF	TEMPW,W
	ENDM
;********************************************************************
PLAY	MACRO	note	;Play one Tone
	MOVE	frequency,note
	CALL	TONE	;Play a tone
	ENDM
;********************************************************************
PULSE	MACRO	port,bit
	BSF	port,bit
	BCF	port,bit
	ENDM
;********************************************************************
;branch to "label" if "time" does not match MINUTES and SECONDS
CHKTIME	MACRO	time,label
	MOVF	time,W
	CALL	CHKTSUB
	BNZ	label
	ENDM
